/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/eptableclass");

    var prefix = 'uieditor_',
        editorName = 'ckeditortestinstance_test1',
        editorId = prefix + editorName,
        editor1 = $('#' + editorId);

    // Instantiate CKE.
    editor1.uiEditor({
        'name' : editorName
    });

    setTimeout(function () {

        QUnit.asyncTest("basic eplineheight plugin tests", function () {
            var editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances[editorId],
                dialog;

            // Reset CKE data.
            editorInstance.setData('');

            // open table dialog
            dialog = editorInstance.openDialog('eptable');

            setTimeout(function () {
                // close dialog
                $('.' + editorClass + ' .cke_dialog_ui_button_ok span').trigger('click');

                // open dialog again and get its instance
                dialog = editorInstance.openDialog('eptable');

                // test if correct CSS class is set
                QUnit.equal(dialog.definition.getContents('advanced').get('advCSSClasses')['default'], 'cke-table', 'default class for table dialog is set to "cke-table"');

                setTimeout(function () {
                    // close dialog
                    $('.' + editorClass + ' .cke_dialog_ui_button_cancel span').trigger('click');

                    // Close submenu.
                    editorInstance.focus();

                    setTimeout(function () {

                        setTimeout(function () {
                            var data = editorInstance.getData(),
                                fragment = $("<div />").html(data),
                                table = fragment.find('table');

                            // test if inserted table has CSS class "cke-table"
                            QUnit.equal(table.hasClass('cke-table'), true, 'inserted table has CSS class "cke-table"');

                            QUnit.start();
                        }, 200);

                    }, 200);

                }, 500);

            }, 1000);
        });

    }, 2000);
});